#
#
# auth_dialog.py
# (c) 2007 Valmantas Paliksa <walmis at balticum-tv dot lt>
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
# 
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# You should have received a copy of the GNU Lesser General Public
# License along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#

import blueman.Globals as Globals
import gtk
import dbus
import gobject
from blueman.Gui.generic_dialog import generic_dialog

_ = Globals._

class auth_dialog(generic_dialog):
	def __init__(self, ok, err, status_callback, address, desc):
		generic_dialog.__init__(self, "auth.glade", "auth")
		
		self.ok = ok
		self.err = err
		self.status_callback = status_callback
        	self.address = address

        	self.xml.signal_autoconnect(self)
        	self.result = None
        	
		self.l_service = self.xml.get_widget("l_service")
		self.l_device = self.xml.get_widget("l_device")
		
		self.l_service.set_markup("<i>" + desc + "</i>")
		
		name = Globals.adapter.GetRemoteName(address)
		
		self.l_device.set_markup("%s <b>(%s)</b>" % (address, name))  
		
		self.dialog.show()    
		#self.gsource = gobject.timeout_add(15000, self.timeout)
		
	def timeout(self):
		self.err(dbus.DBusException("org.bluez.Error.Canceled"))
		self.close()
		return False  
		
      	
   	def __dialog_response__(self, dialog, response):
			
		#authorize
		if response == gtk.RESPONSE_OK:
			print "ok"
			self.ok()
		#reject
		elif response == gtk.RESPONSE_REJECT:
			self.err(dbus.DBusException("org.bluez.Error.Rejected"))
		#trust
		elif response == gtk.RESPONSE_YES:
			
			self.ok()
			Globals.adapter.SetTrusted(self.address)
		#X
		else:
			self.err(dbus.DBusException("org.bluez.Error.Canceled"))
			
		self.close()
		


   			
   			
   	def close(self):
   		self.status_callback(False)
   		self.status_callback = None
   		#self.ok = None
   		##self.err = None
   		#gobject.source_remove(self.gsource)
   		self.__destroy__()

